#!/bin/bash 
VERSION=1.0
###by jiwo.org ҪdownloadأupdateʽΪΪȶļmustc.confҲشûѸ

####
UPDATETYPE=0  ### 0:; 1:
ONLINEVER_FILE="http://www.jiwo.net/musts/update/version"
PKTURLBASE="http://www.jiwo.net/musts/update/"
TMPDIR="/tmp/"
DOWNFILE=$TMPDIR"mustc_update.tgz"
DOWNVERFILE=$TMPDIR"mustc.ver"

OLDVERFILE="/JOS/musts/conf/version"

ERRFILE="/JOS/log/musts/error.update"
DBGFILE="/JOS/log/musts/debug.update"

####ж
if [ "$1" = "-h" -o "$1" = "--help" -o "$1" = "--h" ] ; then
	echo "mustc $VERSION"
	echo "------------------------------------------------------------------------"
	echo "|  Help: mustc update, made by jiwo tech.                               |"
	echo "------------------------------------------------------------------------"
	echo "you can directly input update pkt file or no any input let update from internet."
	echo "Example:"
	echo "	$0 mustc_d9.4_20181107.tgz  (update from local pkt)"
	echo "	$0  (update from internet)"
	echo ""
	exit
elif [ "$1" != "" ]; then
	UPDATETYPE=1
fi

###غ
downfile_func()
{
	wget $1 -O $DOWNFILE -t3 -T9 -q
	FILESIZE=`stat -c%s $DOWNFILE`
	if [ $FILESIZE -le 1 ]; then
		return 1  ###س
	else
		return 0
	fi
}

#######жǷҪ#######
wget $ONLINEVER_FILE -O $DOWNVERFILE -t3 -T9 -q
FILESIZE=`stat -c%s $DOWNVERFILE`
if [ $FILESIZE -le 1 ]; then
	echo "Get online version failed when updating !" >> $ERRFILE
	exit
fi

newver=`cat $DOWNVERFILE`
oldver=`cat $OLDVERFILE`

if [ $oldver -ge $newver ]; then  ###а汾ڵ߰汾Ҫ
	exit
fi

echo "Update mustc ..." >> $DBGFILE
#######!!!ʼ!!!#######

if [ $UPDATETYPE = 0 ] ; then
	####簲װжϲϵͳ
	os=""
	vernum_main="0"
	vernum_sub="0"
	if [ -f "/etc/centos-release" ]; then  ###centos,ǰ
		os="c"
		osinfo=`cat /etc/centos-release`
		###CentOS Linux release 7.5.1804 (Core) 
		re="release ([0-9]+)\.([0-9]+).*"
		if [[ $osinfo =~ $re ]]; then
			vernum_main=${BASH_REMATCH[1]}
			vernum_sub=${BASH_REMATCH[2]}
		fi
		echo "Guess os is [CentOS], vernum=[$vernum_main.$vernum_sub]" >> $DBGFILE

	elif [ -f "/etc/redhat-release" ]; then  ###redhat,CentOSжϺ
		os="r"
		osinfo=`cat /etc/redhat-release`
		###Red Hat Enterprise Linux Server release 6.5 (Santiago)
		re="release ([0-9]+)\.([0-9]+).*"
		if [[ $osinfo =~ $re ]]; then
			vernum_main=${BASH_REMATCH[1]}
			vernum_sub=${BASH_REMATCH[2]}
		fi
		echo "Guess os is [RedHat], vernum=[$vernum_main.$vernum_sub]" >> $DBGFILE

	elif [ -f "/etc/debian_version" ]; then  ###debianubuntu
		debian=`cat /etc/issue|grep ebian`
		ubuntu=`cat /etc/issue|grep buntu`

		if [ "$debian" != "" ]; then
			os="d"
			osinfo=`cat /etc/debian_version`
			re="([0-9]+)\.([0-9]+).*"
			if [[ $osinfo =~ $re ]]; then
				vernum_main=${BASH_REMATCH[1]}
				vernum_sub=${BASH_REMATCH[2]}
			fi
			echo "Guess os is [Debian], vernum=[$vernum_main.$vernum_sub]" >> $DBGFILE

		elif [ "$ubuntu" != "" ]; then
			os="u"
			osinfo=`cat /etc/issue`
			###Ubuntu 14.04.1 LTS \n \l
			re="([0-9]+)\.([0-9]+).*"
			if [[ $osinfo =~ $re ]]; then
				vernum_main=${BASH_REMATCH[1]}
				vernum_sub=${BASH_REMATCH[2]}
			fi
			echo "Guess os is [Ubuntu], vernum=[$vernum_main.$vernum_sub]" >> $DBGFILE

		fi
	fi
	########ϵͳж########

	########ضӦ########
	PKTURL=$PKTURLBASE"mustc_$os$vernum_main.$vernum_sub""_$newver.tgz"
	downfile_func "$PKTURL"
	if [ $? = 1 ]; then  ###δȡװԻȡ֧
		PKTURL=$PKTURLBASE"mustc_$os$vernum_main""_$newver.tgz"
		downfile_func "$PKTURL"
		if [ $? = 1 ]; then
			echo "!!! Can not download update pkt, Please contact jiwo.ltd, exit ... !!!" >> $ERRFILE
			exit
		fi
	fi
fi

#######ѹװ#######
if [ "$1" != "" ]; then
	srcpkt=$1
else
	srcpkt=$DOWNFILE
fi

tar zxvf $srcpkt -C / >/dev/null

chmod +x /JOS/musts/sbin -R
chmod +x /JOS/musts/bin -R

#export PATH="${PATH:+$PATH:}/JOS/musts/bin"
export PATH=$PATH:/JOS/musts/bin


#######ɱϽ̣½#######
killall -9 mustc
killall -9 mustc
/JOS/musts/bin/mustc -s "$newver" -D

echo "Update mustc end!" >> $DBGFILE
#echo "uptover=$newver"
